;; Mode: Scheme

;; *************************************************************************
;; Copyright (c) 1992 Xerox Corporation.  
;; All Rights Reserved.  
;;
;; Use, reproduction, and preparation of derivative works are permitted.
;; Any copy of this software or of any derivative work must include the
;; above copyright notice of Xerox Corporation, this paragraph and the
;; one after it.  Any distribution of this software or derivative works
;; must comply with all applicable United States export control laws.
;;
;; This software is made available AS IS, and XEROX CORPORATION DISCLAIMS
;; ALL WARRANTIES, EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION THE
;; IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
;; PURPOSE, AND NOTWITHSTANDING ANY OTHER PROVISION CONTAINED HEREIN, ANY
;; LIABILITY FOR DAMAGES RESULTING FROM THE SOFTWARE OR ITS USE IS
;; EXPRESSLY DISCLAIMED, WHETHER ARISING IN CONTRACT, TORT (INCLUDING
;; NEGLIGENCE) OR STRICT LIABILITY, EVEN IF XEROX CORPORATION IS ADVISED
;; OF THE POSSIBILITY OF SUCH DAMAGES.
;; *************************************************************************

;;
;; Scheme is such a wonderful language, you can't program in it!
;;

;;; Scsh support for tiny-clos
;; Emilio Lopes <eclig@gmx.net>

;; requires structure `sort'
(define gsort
  (lambda (predicate items)
    (sort-list items predicate)))

(define ??? 'unspecified-result)

;; `list-index' comes from srfi-1
(define position-of
  (lambda (item lst)
    (list-index (lambda (x) (eq? x item)) lst)))

(define getl
  (lambda (initargs name . not-found)
    (letrec ((scan (lambda (tail)
                     (cond ((null? tail)
                            (if (pair? not-found)
                                (car not-found)
                                (error "GETL couldn't find" name)))
                           ((eq? (car tail) name)
                            (cadr tail))
                           (else
                            (scan (cddr tail)))))))
      (scan initargs))))

;; `filter' comes from srfi-1
(define collect-if filter)
