;; Test for `ranqd1'.  The sequence of expected random numbers was
;; taken from http://lib-www.lanl.gov/numerical/bookfpdf/f7-1.pdf.
;;
;; Emilio C. Lopes <eclig@gmx.net>, 2005-01-04.

(load "ranqd1.scm")

(let ((random (gen-ranqd1 0))
      (expected-results '(#x3c6ef35f
                          #x47502932
                          #xd1ccf6e9
                          #xaaf95334
                          #x6252e503
                          #x9f2ec686
                          #x57fe6c2d
                          #xa3d95fa8
                          #x81fdbee7
                          #x94f0af1a
                          #xcbf633b1)))
  (for-each (lambda (expected)
              (let ((rnd (random)))
                (if (not (= rnd expected))
                    (error (format #f "FAILED: expected ~a, got ~a" expected rnd)))))
            expected-results))

